<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UsageSearchRow StructType
 * @subpackage Structs
 */
class UsageSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\UsageSearchRowBasic
     */
    public $basic;
    /**
     * The chargeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ChargeSearchRowBasic
     */
    public $chargeJoin;
    /**
     * The customerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchRowBasic
     */
    public $customerJoin;
    /**
     * The itemJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemSearchRowBasic
     */
    public $itemJoin;
    /**
     * The subscriptionPlanJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemSearchRowBasic
     */
    public $subscriptionPlanJoin;
    /**
     * Constructor method for UsageSearchRow
     * @uses UsageSearchRow::setBasic()
     * @uses UsageSearchRow::setChargeJoin()
     * @uses UsageSearchRow::setCustomerJoin()
     * @uses UsageSearchRow::setItemJoin()
     * @uses UsageSearchRow::setSubscriptionPlanJoin()
     * @param \StructType\UsageSearchRowBasic $basic
     * @param \StructType\ChargeSearchRowBasic $chargeJoin
     * @param \StructType\CustomerSearchRowBasic $customerJoin
     * @param \StructType\ItemSearchRowBasic $itemJoin
     * @param \StructType\ItemSearchRowBasic $subscriptionPlanJoin
     */
    public function __construct(\StructType\UsageSearchRowBasic $basic = null, \StructType\ChargeSearchRowBasic $chargeJoin = null, \StructType\CustomerSearchRowBasic $customerJoin = null, \StructType\ItemSearchRowBasic $itemJoin = null, \StructType\ItemSearchRowBasic $subscriptionPlanJoin = null)
    {
        $this
            ->setBasic($basic)
            ->setChargeJoin($chargeJoin)
            ->setCustomerJoin($customerJoin)
            ->setItemJoin($itemJoin)
            ->setSubscriptionPlanJoin($subscriptionPlanJoin);
    }
    /**
     * Get basic value
     * @return \StructType\UsageSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\UsageSearchRowBasic $basic
     * @return \StructType\UsageSearchRow
     */
    public function setBasic(\StructType\UsageSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get chargeJoin value
     * @return \StructType\ChargeSearchRowBasic|null
     */
    public function getChargeJoin()
    {
        return $this->chargeJoin;
    }
    /**
     * Set chargeJoin value
     * @param \StructType\ChargeSearchRowBasic $chargeJoin
     * @return \StructType\UsageSearchRow
     */
    public function setChargeJoin(\StructType\ChargeSearchRowBasic $chargeJoin = null)
    {
        $this->chargeJoin = $chargeJoin;
        return $this;
    }
    /**
     * Get customerJoin value
     * @return \StructType\CustomerSearchRowBasic|null
     */
    public function getCustomerJoin()
    {
        return $this->customerJoin;
    }
    /**
     * Set customerJoin value
     * @param \StructType\CustomerSearchRowBasic $customerJoin
     * @return \StructType\UsageSearchRow
     */
    public function setCustomerJoin(\StructType\CustomerSearchRowBasic $customerJoin = null)
    {
        $this->customerJoin = $customerJoin;
        return $this;
    }
    /**
     * Get itemJoin value
     * @return \StructType\ItemSearchRowBasic|null
     */
    public function getItemJoin()
    {
        return $this->itemJoin;
    }
    /**
     * Set itemJoin value
     * @param \StructType\ItemSearchRowBasic $itemJoin
     * @return \StructType\UsageSearchRow
     */
    public function setItemJoin(\StructType\ItemSearchRowBasic $itemJoin = null)
    {
        $this->itemJoin = $itemJoin;
        return $this;
    }
    /**
     * Get subscriptionPlanJoin value
     * @return \StructType\ItemSearchRowBasic|null
     */
    public function getSubscriptionPlanJoin()
    {
        return $this->subscriptionPlanJoin;
    }
    /**
     * Set subscriptionPlanJoin value
     * @param \StructType\ItemSearchRowBasic $subscriptionPlanJoin
     * @return \StructType\UsageSearchRow
     */
    public function setSubscriptionPlanJoin(\StructType\ItemSearchRowBasic $subscriptionPlanJoin = null)
    {
        $this->subscriptionPlanJoin = $subscriptionPlanJoin;
        return $this;
    }
}
